#include <stdio.h>
#include <math.h>
#include <lcms.h>

#define d(x) ((double) (x))

void 
xyz2rgbA(double color[3],double gamma) 
{
	// coded directly from LabWarp mainicm.pas
	double vX,vY,vZ,vR,vG,vB;
	
	vX = color[0] / 100.0;
	vY = color[1] / 100.0;
	vZ = color[2] / 100.0;
	
	vR = (vX *  3.2410) + (vY * -1.5374) + (vZ * -0.4986);
	vG = (vX * -0.9692) + (vY *  1.8760) + (vZ *  0.0416);
	vB = (vX *  0.0556) + (vY * -0.2040) + (vZ *  1.0570);
	
	vR = ( vR >0.00304 ? (1.055 * pow(vR,(1.0/gamma))) - 0.055 : 12.92 * vR );
	vG = ( vG >0.00304 ? (1.055 * pow(vG,(1.0/gamma))) - 0.055 : 12.92 * vG );
	vB = ( vB >0.00304 ? (1.055 * pow(vB,(1.0/gamma))) - 0.055 : 12.92 * vB );

	
	if (vR < 0.0) { vR = 0.0; }
	if (vG < 0.0) { vG = 0.0; }
	if (vB < 0.0) { vB = 0.0; }
	
	if (vR > 1.0) { vR = 1.0; }
	if (vG > 1.0) { vG = 1.0; }
	if (vB > 1.0) { vB = 1.0; }
	

	/*
	color[0]  = (WORD) ( 0.5 + (vR * 0xffff));
	color[1]  = (WORD) ( 0.5 + (vG * 0xffff));
	color[2]  = (WORD) ( 0.5 + (vB * 0xffff));
	*/

	color[0]  = vR * d(0xffff);
	color[1]  = vG * d(0xffff);
	color[2]  = vB * d(0xffff);
}


void 
rgb2xyzA(double color[3], double gamma) {
  // coded directly from LabWarp mainicm.pas
  // 2 deg observer, D65 Illuminant
  double vR,vG,vB;

  vR = color[0] / d(0xffff);
  vG = color[1] / d(0xffff);
  vB = color[2] / d(0xffff);

  
  vR = ( vR > 0.03928 ? pow( (vR + 0.055) / 1.055, gamma) : vR / 12.92 );
  vG = ( vG > 0.03928 ? pow( (vG + 0.055) / 1.055, gamma) : vG / 12.92 );
  vB = ( vB > 0.03928 ? pow( (vB + 0.055) / 1.055, gamma) : vB / 12.92 );
  
  /*
  vR = pow(vR,gamma);
  vG = pow(vG,gamma);
  vB = pow(vB,gamma);
  */

  vR *= 100.0;
  vG *= 100.0;
  vB *= 100.0;
  
  color[0] = (vR * 0.4124) + (vG * 0.3576) + (vB * 0.1805);
  color[1] = (vR * 0.2126) + (vG * 0.7152) + (vB * 0.0722);
  color[2] = (vR * 0.0193) + (vG * 0.1192) + (vB * 0.9505);

}



main() {
  int i;
  double color[3];
  double gam=2.2;
  //for (i=0;i<10;i++) {
  //color[0] = color[1] = color[2] = (double) i*1000;
  color[0] = 0.0;
  color[1] = 7978.0;
  //color[2] = 34129.0;
  color[2] = 8000.0;

    printf("%5.2f %5.2f %5.2f   ",color[0],color[1],color[2]);

    rgb2xyzA(color,gam);

    printf("%5.2f %5.2f %5.2f   ",color[0],color[1],color[2]);

    xyz2rgbA(color,gam);

    printf("%5.2f %5.2f %5.2f   ",color[0],color[1],color[2]);

    printf("\n");
    //}
}
